std::isnormal(3)

NAME
std::isnormal - std::isnormal

Synopsis
   Defined in header <cmath>
   bool isnormal( float arg ); (1) (since C++11)
                        (constexpr since C++23)
   bool isnormal( double arg ); (2) (since C++11)
                        (constexpr since C++23)
   bool isnormal( long double arg ); (3) (since C++11)
                        (constexpr since C++23)
   bool isnormal( IntegralType arg ); (4) (since C++11)
                        (constexpr since C++23)
   1-3) Determines if the given floating point number arg is normal, i.e. is neither
   zero, subnormal, infinite, nor NaN.
   4) A set of overloads or a function template accepting the arg argument of any
   integral type. Equivalent to (2) (the argument is cast to double).

Parameters
   arg - floating point value

Return value
   true if arg is normal, false otherwise

Example
// Run this code
 #include <iostream>
 #include <cmath>
 #include <cfloat>
 int main()
 {
     std::cout << std::boolalpha
               << "isnormal(NaN) = " << std::isnormal(NAN) << '\n'
               << "isnormal(Inf) = " << std::isnormal(INFINITY) << '\n'
               << "isnormal(0.0) = " << std::isnormal(0.0) << '\n'
               << "isnormal(DBL_MIN/2.0) = " << std::isnormal(DBL_MIN/2.0) << '\n'
               << "isnormal(1.0) = " << std::isnormal(1.0) << '\n';
 }

Output:
 isnormal(NaN) = false
 isnormal(Inf) = false
 isnormal(0.0) = false
 isnormal(DBL_MIN/2.0) = false
 isnormal(1.0) = true

See also
   fpclassify categorizes the given floating-point value
   (C++11) (function)
   isfinite checks if the given number has finite value
   (C++11) (function)
   isinf checks if the given number is infinite
   (C++11) (function)
   isnan checks if the given number is NaN
   (C++11) (function)